fn main() {
    println!("Hello, world!");
}

mod rover {
    #[derive(Debug,PartialEq)]
    pub enum Facing { N, E, S, W }

    type Rover = (i32, i32, Facing);

    pub fn forward(r : Rover) -> Rover {
	(1 as i32, 0 as i32, Facing::N)
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn rover_run() {
	assert_eq!(1,1);
	let r = (1 as i32, 1 as i32, rover::Facing::N);
	assert_eq!(rover::forward(r),
		   (1 as i32, 0 as i32, rover::Facing::N));
    }
}
